<template>
  <div id="app">
    <b-card style="margin: 10px">
      <h6 slot="header" class="mb-0" style="font-weight: bold">Submissions</h6>
      <div v-if="this.doneLoading">
        <div v-for="competition in competitions" :key="competition._id">
          <submissions-by-competition-panel
              :competition="competition"
              :submissions="competitionSubmissionsMap[competition._id]"/>
        </div>
      </div>
    </b-card>
  </div>
</template>

<script>
import SubmissionsByCompetitionPanel from '@/components/SubmissionsByCompetitionPanel'

import Competition from '@/models/Competition'
import Submission from '@/models/Submission'
import backend from '@/backend-manager'

export default {
    created: async function () {
        this.submissions = await backend.getInstance().getSubmissionListForUser()
        this.createChainedSubmissionMap()
        this.competitions = await this.getAllCompetitions()
        this.doneLoading = true
    },
    components: {
        SubmissionsByCompetitionPanel: SubmissionsByCompetitionPanel
    },
    data: function () {
        return {
            submissions: [],
            competitions: {},
            competitionSubmissionsMap: {},
            doneLoading: false
        }
    },
    methods: {
        getAllCompetitions: async function() {
            var competitions = {}
            for (var i = 0; i < this.submissions.length; i++) {
                var submission = this.submissions[i]

                console.log('Got submission: ' + JSON.stringify(submission))
                console.log('Getting competition: ' + submission.getCompetitionId())
                
                if (!competitions[submission.getCompetitionId()]) {
                    var competition = new Competition(submission.getCompetitionId())
                    await competition.load()
                    competitions[competition._id] = competition
                }
            }
            console.log('returning ' + JSON.stringify(competitions))
            return competitions
        },
        createChainedSubmissionMap: function() {
            for (var i = 0; i < this.submissions.length; i++) {
                var submission = this.submissions[i]
                
                if (!this.competitionSubmissionsMap[submission.getCompetitionId()]) {
                    this.competitionSubmissionsMap[submission.getCompetitionId()] = []
                }

                this.competitionSubmissionsMap[submission.getCompetitionId()].push(submission)
            }
        }
    }
}
</script>
